/****************************************************************************/
#ifndef DEFINE_SPRITE
  typedef struct _SPRITE {
	unsigned char bmpno;	/* +0,1: rbg}bvԍ */
	unsigned char revx:1;	/* +1,1: E]         */
	unsigned char revy:1;	/*       ㉺]         */
	unsigned char x, y;	/* +2,2: W         */
	unsigned char w, h;	/* +4,2: A         */
	         char cx, cy;	/* +6,2: _ItZbg   */
  } SPRITE;
  enum {
  #define SPRITE(name,bmpno,revx,revy,x,y,w,h,cx,cy) name,
#else /*DEFINE_SPRITE*/
  const SPRITE sprite_table[SPRITE_COUNT] = {
  #define SPRITE(name,bmpno,revx,revy,x,y,w,h,cx,cy) {bmpno,revx,revy,x,y,w,h,cx,cy},
#endif /*DEFINE_SPRITE*/
/****************************************************************************/
/*{{AvP[V`*/

/*SPRITE(<name>,<bmpno>,<revx>,<revy>,<x>,<y>,<w>,<h>,<cx>,<cy>)*/

/*}}AvP[V`*/
/****************************************************************************/
#ifndef DEFINE_SPRITE
  #undef SPRITE
    SPRITE_COUNT,
  };
  extern const SPRITE sprite_table[SPRITE_COUNT];
#else /*DEFINE_SPRITE*/
  #undef SPRITE
  };
  void draw_sprite(int x, int y, int sprno) {
    extern RENDER render;
    const SPRITE* sprite;
    if(sprno < 0 || SPRITE_COUNT - 1 < sprno) DIE();
    sprite = &sprite_table[sprno];
    /*{{AvP[V`*/
    {
      extern PIECE_BMP pat2, pat2m;
      switch(sprite->bmpno) {
      case 0:  render.context->texture = &pat2;  break;
      case 1:  render.context->texture = &pat2m; break;
      default: DIE();
      }
    }
    /*}}AvP[V`*/
    render_object(&render,
      x - sprite->cx, y - sprite->cy, sprite->x, sprite->y, sprite->w, sprite->h,
      (sprite->revx ? DRW_REVX : 0) | (sprite->revy ? DRW_REVY : 0));
  }
#endif /*DEFINE_SPRITE*/
/****************************************************************************/
