/*
 *	main.c
 *
 *	hbN/EMU
 *
 *	* Tue Nov 26 06:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

//#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#include "instdef.c"
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

//#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
//#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/* XvCg`BKvɉăCN[hĂBsprite.h̕ҏWKvłB */
//#include "sprite.h"
//#define DEFINE_SPRITE
//#include "sprite.h"
//#undef  DEFINE_SPRITE

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

//extern const unsigned char PAT[];
//extern const unsigned char BG[];
//TEXTURE pat;
//TEXTURE bg;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
void run();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	run();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(1/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_MUSIC
	/* yCu܂B */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

/*{{AvP[VL̏*/
	turbo(7); /* 48MHz/1WAIT */
	//srand(pceTimerGetCount());
	/* rbg}bvB */
	//texture_init(&pat, PAT);
	//texture_init(&bg, BG);
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(/*joy & TRG_START  PAUSEȂ*/0) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	run
 ****************************************************************************/

#define TARGET_CPU_CLOCK	4000000
#define TARGET_FPS		60

typedef struct _TARGET {
	Z80 z80;
	unsigned char mem[0x10000];	/* 0x0000-0x3fff:ROM; 0x8000-0x87ff:VRAM/WORK */
	unsigned char input;
	unsigned char palette;
} TARGET;
TARGET g_target;

typedef struct _ROM {
	const char* name;
	unsigned short base;
	unsigned short size;
	unsigned crc;
} ROM;
#define ROMSET_FNAME	"dotrikun.zip"
const ROM roms[] = {
	{ "14479a.mpr", 0x0000, 0x4000, 0xb77a50db },
	{ NULL },
};

unsigned char
target_z80_read(Z80* z80, unsigned short addr)
{
	TARGET* target = (TARGET*)z80;
	return target->mem[addr];
}

void
target_z80_write(Z80* z80, unsigned short addr, unsigned char data)
{
	TARGET* target = (TARGET*)z80;
	target->mem[addr] = data;
}

unsigned char
target_z80_in(Z80* z80, unsigned short addr)
{
	TARGET* target = (TARGET*)z80;
	if((addr & 0xff) != 0x00) return -1;
	return target->input;
}

void
target_z80_out(Z80* z80, unsigned short addr, unsigned char data)
{
	TARGET* target = (TARGET*)z80;
	if((addr & 0xff) != 0x00) return;
	target->palette = data;
}

void
update_input(TARGET* target)
{
	unsigned char input = 0;
	if(joy & PAD_UP    ) input |= 0x01; /* UP      */
	if(joy & PAD_DN    ) input |= 0x02; /* DOWN    */
	if(joy & PAD_LF    ) input |= 0x04; /* LEFT    */
	if(joy & PAD_RI    ) input |= 0x08; /* RIGHT   */
	if(joy & PAD_A     ) input |= 0x10; /* BUTTON1 */
	if(joy & PAD_B     ) input |= 0x20; /* BUTTON2 */
	if(joy & PAD_START ) input |= 0x40; /* START   */
	if(joy & PAD_SELECT) input |= 0x80; /* COIN    */
	target->input = ~input; /* _ */
}

void
update_video(TARGET* target)
{
	unsigned char* dst = vbuff;
	unsigned char* src = &target->mem[0x8000 + (128 / 8) * ((96 - 88) / 2)]; /* ʂ128x96Ȃ̂ŁA㉺4sNZ؂܂ */
	unsigned char fore, back;
	int i, n;

	fore = (target->palette      & 7/*BGR*/) ? 0 : 3;
	back = (target->palette >> 3 & 7/*BGR*/) ? 0 : 3;

	i = 128 * (/*96*/88 / 8);
	do {
		n = *src++;
		*dst++ = n & 0x80 ? fore : back;
		*dst++ = n & 0x40 ? fore : back;
		*dst++ = n & 0x20 ? fore : back;
		*dst++ = n & 0x10 ? fore : back;
		*dst++ = n & 0x08 ? fore : back;
		*dst++ = n & 0x04 ? fore : back;
		*dst++ = n & 0x02 ? fore : back;
		*dst++ = n & 0x01 ? fore : back;
	} while(--i);
}

void
load_rom(TARGET* target)
{
	int retval;
	unsigned char* mem = target->mem;
	const ROM* rom;
	unz_file_info ufi;

	/* ROMǂݍ݁B */
	rom = roms;
	while(rom->name) {
		retval = my_unzip(ROMSET_FNAME, rom->name, &target->mem[rom->base], rom->size, &ufi);
		if(retval != rom->size || ufi.crc != rom->crc) {
			die("ERR: %s", rom->name); /* G[bZ[WpceFontPrintf()ŗ̂Œ!! */
		}
		rom++;
	}

	/* pb`āFA荞ݑ҂̃rW[[vHALTɕύXB
	 * 0x0216: 210786 LD HL, 0x8607
	 * 0x0219: CB7E   BIT 7, (HL) // A荞݃[`-1܂
	 * 0x021B: 28FC   JR Z, 0x0219  => { 76 HALT; 00 NOP }
	 * 0x021D: 3600   LD (HL), 0x00
	 * 0x021F: C9     RET
	 */
	mem[0x021b] = 0x76; /* HALT */
	mem[0x021c] = 0x00; /* NOP  */
}

void
run()
{
	int i;
	TARGET* target = &g_target;
	Z80* z80 = &target->z80;

	/* ROMǂݍ݁B */
	load_rom(target);

	/* CPUZbgB */
	z80_reset(z80, target_z80_read, target_z80_write, target_z80_in, target_z80_out);

	for(;;) {
		schedule();
		update_input(target);

		ASSERT((TARGET_FPS / FPS) * FPS == TARGET_FPS); /* {ł邱!! */
		for(i = 0; i < TARGET_FPS / FPS; i++) {
			z80_run(z80, TARGET_CPU_CLOCK / TARGET_FPS);
			z80_int(z80, -1);
		}

		update_video(target);
	}
}
